diff -r -u -H -N gcc-2.6.3/reload.c gcc-i2.6.3/reload.c
--- gcc-2.6.3/reload.c	Thu Oct 27 13:04:09 1994
+++ gcc-i2.6.3/reload.c	Wed Feb 15 22:47:18 1995
@@ -4024,6 +4024,10 @@
 {
   register int regno;
   rtx tem;
+#ifdef REWRITE_ADDRESS
+  /* intel1 */
+  rtx rewrite_address();
+#endif
 
   /* If the address is a register, see if it is a legitimate address and
      reload if not.  We first handle the cases where we need not reload
@@ -4289,6 +4293,37 @@
 	}
     }
 
+  /* intel1 - even if one of the registers is still a pseudo
+             subst_reg_equivs may be able to substitute a
+             constant for it too */
+    else
+             
+    if (tem != ad && memory_address_p (mode, tem))
+      {
+        rtx tmp_rtx;
+        tmp_rtx = copy_rtx (tem);
+	/* Ok, we win that way.  Replace any additional eliminable
+	   registers.  */
+	subst_reg_equivs_changed = 0;
+	tmp_rtx = subst_reg_equivs (tmp_rtx);
+#ifdef REWRITE_ADDRESS
+	if (!strict_memory_address_p (mode, tmp_rtx))
+	  {
+            tmp_rtx = gen_rtx (MEM, mode, tmp_rtx);
+            REWRITE_ADDRESS (tmp_rtx);
+            tmp_rtx = XEXP (tmp_rtx, 0);
+	  }
+#endif
+
+	/* Make sure that didn't make the address invalid again.  */
+
+	if (strict_memory_address_p (mode, tmp_rtx))
+	  {
+	    *loc = tmp_rtx;
+	    return 0;
+	  }
+	
+      }
   /* If constants aren't valid addresses, reload the constant address
      into a register.  */
   if (CONSTANT_P (ad) && ! strict_memory_address_p (mode, ad))
diff -r -u -H -N gcc-2.6.3/reload.h gcc-i2.6.3/reload.h
--- gcc-2.6.3/reload.h	Mon Oct 17 11:28:49 1994
+++ gcc-i2.6.3/reload.h	Wed Feb 15 22:47:19 1995
@@ -234,3 +234,15 @@
 
 /* Find the places where hard regs are live across calls and save them.  */
 extern void save_call_clobbered_regs PROTO((enum machine_mode));
+/* intel1 */
+#define MAX_RELOAD_STACK_SLOTS 100
+struct reload_slot_info {
+    rtx  reload_stack_slot;
+    rtx  reload_insn;
+    rtx last_store;
+    int is_loaded_to_reg;
+    int stack_slot_pseudo_reg;
+    int cur_stack_offset;
+    char reload_stack_mode;
+    unsigned reload_slot_updated:1;
+    } ;
diff -r -u -H -N gcc-2.6.3/reload1.c gcc-i2.6.3/reload1.c
--- gcc-2.6.3/reload1.c	Sat Nov  5 13:57:29 1994
+++ gcc-i2.6.3/reload1.c	Thu Feb 16 12:19:37 1995
@@ -75,6 +75,8 @@
 #ifndef MEMORY_MOVE_COST
 #define MEMORY_MOVE_COST(x) 4
 #endif
+/* intel1 */
+static int cur_stack_offset;
 
 /* During reload_as_needed, element N contains a REG rtx for the hard reg
    into which reg N has been reloaded (perhaps for a previous insn). */
@@ -261,6 +263,9 @@
 #define obstack_chunk_alloc xmalloc
 #define obstack_chunk_free free
 
+/* intel1 */
+extern FILE * global_reg_dump_file;
+
 /* List of labels that must never be deleted.  */
 extern rtx forced_labels;
 
@@ -301,6 +306,15 @@
 
 #define NUM_ELIMINABLE_REGS (sizeof reg_eliminate / sizeof reg_eliminate[0])
 
+/* intel1 */
+/* information for loop_after_global optimizations */
+struct reload_slot_info reload_slots[MAX_RELOAD_STACK_SLOTS];
+int num_reload_stack_slots=0;
+static rtx treplace_insn = NULL_RTX;
+
+/* is 1 is the pseudo has been spilled */
+int * pseudo_spilled;
+
 /* Record the number of pending eliminations that have an offset not equal
    to their initial offset.  If non-zero, we use a new copy of each
    replacement result in any insns encountered.  */
@@ -365,6 +379,8 @@
 static void inc_for_reload		PROTO((rtx, rtx, int));
 static int constraint_accepts_reg_p	PROTO((char *, rtx));
 static int count_occurrences		PROTO((rtx, rtx));
+/* intel1 */
+int is_a_param_slot();
 
 /* Initialize the reload pass once per compilation.  */
 
@@ -459,6 +475,26 @@
   /* The basic block number currently being processed for INSN.  */
   int this_block;
 
+  /* intel1 */
+  /* intel1. Look for insns whose src is equal to dest and delete them.  */
+  for (insn = next_nonnote_insn (first); insn; insn = next_nonnote_insn (insn))
+    {
+      if (GET_CODE (insn) == INSN 
+          && GET_CODE (PATTERN (insn)) == SET
+          && !(GET_CODE (SET_SRC (PATTERN (insn))) == MEM
+               && MEM_VOLATILE_P (SET_SRC (PATTERN (insn))))
+          && rtx_equal_p (SET_SRC (PATTERN (insn)), SET_DEST (PATTERN (insn))))
+        {
+	  PUT_CODE (insn, NOTE);
+	  NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+	  NOTE_SOURCE_FILE (insn) = 0;
+        }
+    }
+  num_reload_stack_slots = 0;
+  pseudo_spilled = (int *)alloca(max_regno*sizeof(int));
+  bzero(pseudo_spilled,max_regno*sizeof(int));
+  bzero(reload_slots,MAX_RELOADS*sizeof(struct reload_slot_info));
+
   /* Make sure even insns with volatile mem refs are recognizable.  */
   init_recog ();
 
@@ -804,6 +840,9 @@
 
       num_not_at_initial_offset = 0;
 
+	  /* intel1 */
+	  cur_stack_offset = 0;
+
       bzero ((char *) &offsets_known_at[get_first_label_num ()], num_labels);
 
       /* Set a known offset for each forced label to be at the initial offset
@@ -1937,6 +1976,42 @@
 
   reload_in_progress = 0;
 
+  /* intel1 */
+  for (insn = first; insn; insn = NEXT_INSN (insn))
+    {
+      if (GET_CODE (insn) == INSN && GET_CODE (PATTERN (insn)) == SET
+          && GET_CODE (SET_DEST (PATTERN (insn))) == REG
+          && GET_CODE (SET_SRC (PATTERN (insn))) == REG)
+        {
+          if (REGNO (SET_DEST (PATTERN (insn))) < FIRST_PSEUDO_REGISTER
+              && REGNO (SET_SRC (PATTERN (insn))) >= FIRST_PSEUDO_REGISTER
+              && reg_equiv_mem[REGNO (SET_SRC (PATTERN (insn)))]
+              && reg_renumber[REGNO (SET_SRC (PATTERN (insn)))] < 0
+              && RTX_IS_SPILL_P (reg_equiv_mem[REGNO (SET_SRC (PATTERN (insn)))])
+              && !RTX_IS_SPILL_P (insn))
+            {
+              RTX_IS_SPILL_P (insn) = 1;
+              SPILL_PSEUDO (insn) = REGNO (SET_SRC (PATTERN (insn)));
+            }
+          if (REGNO (SET_DEST (PATTERN (insn))) >= FIRST_PSEUDO_REGISTER
+              && REGNO (SET_SRC (PATTERN (insn))) < FIRST_PSEUDO_REGISTER
+              && reg_equiv_mem[REGNO (SET_DEST (PATTERN (insn)))]
+              && reg_renumber[REGNO (SET_DEST (PATTERN (insn)))] < 0
+              && RTX_IS_SPILL_P (reg_equiv_mem[REGNO (SET_DEST (PATTERN (insn)))])
+              && !RTX_IS_SPILL_P (insn))
+            {
+              RTX_IS_SPILL_P (insn) = 1;
+              SPILL_PSEUDO (insn) = REGNO (SET_DEST (PATTERN (insn)));
+            }
+  if (scratch_list)
+    free (scratch_list);
+  scratch_list = 0;
+  if (scratch_block)
+    free (scratch_block);
+  scratch_block = 0;
+
+        }
+    }
   /* Now eliminate all pseudo regs by modifying them into
      their equivalent memory references.
      The REG-rtx's for the pseudos are modified in place,
@@ -1998,13 +2073,17 @@
   reg_equiv_constant = 0;
   reg_equiv_memory_loc = 0;
 
-  if (scratch_list)
-    free (scratch_list);
-  scratch_list = 0;
-  if (scratch_block)
-    free (scratch_block);
-  scratch_block = 0;
-
+  /* intel1 */
+  if (num_reload_stack_slots == MAX_RELOAD_STACK_SLOTS)
+    { /* Too many so don't use any */
+      for (insn = first; insn ; insn = next_nonnote_insn (insn))
+        {
+          if (GET_CODE (insn) == INSN )
+            {
+              RTX_IS_SPILL_P (insn) = 0;
+            }
+        }
+    }
   return failure;
 }
 
@@ -2303,6 +2382,15 @@
   REGNO (regno_reg_rtx[i])
     = reg_renumber[i] >= 0 ? reg_renumber[i] : i;
 
+  /* intel1 */
+  if (reg_renumber[i] < 0 
+      && reg_equiv_memory_loc[i] != 0
+      && is_a_param_slot (reg_equiv_memory_loc[i]))
+    {
+      pseudo_spilled[i] = 1;
+      RTX_IS_SPILL_P (reg_equiv_memory_loc[i]) = 1;
+      RTX_IS_SPILL_P (XEXP (reg_equiv_memory_loc[i], 0)) = 1;
+    }
   /* If we have a pseudo that is needed but has no hard reg or equivalent,
      allocate a stack slot for it.  */
 
@@ -2316,6 +2404,8 @@
       int total_size = MAX (inherent_size, reg_max_ref_width[i]);
       int adjust = 0;
 
+      /* intel1 */
+      pseudo_spilled[i] = 1;
       /* Each pseudo reg has an inherent size which comes from its own mode,
 	 and a total size which provides room for paradoxical subregs
 	 which refer to the pseudo reg in wider modes.
@@ -2328,6 +2418,9 @@
 	{
 	  /* No known place to spill from => no slot to reuse.  */
 	  x = assign_stack_local (GET_MODE (regno_reg_rtx[i]), total_size, -1);
+	  /* intel1 */
+	  RTX_IS_SPILL_P (x) = 1;
+	  RTX_IS_SPILL_P (XEXP (x, 0)) = 1;
 #if BYTES_BIG_ENDIAN
 	  /* Cancel the  big-endian correction done in assign_stack_local.
 	     Get the address of the beginning of the slot.
@@ -2341,7 +2434,9 @@
 	       && spill_stack_slot_width[from_reg] >= total_size
 	       && (GET_MODE_SIZE (GET_MODE (spill_stack_slot[from_reg]))
 		   >= inherent_size))
+        {
 	x = spill_stack_slot[from_reg];
+ 	}
       /* Allocate a bigger slot.  */
       else
 	{
@@ -2358,6 +2453,9 @@
 	    }
 	  /* Make a slot with that size.  */
 	  x = assign_stack_local (mode, total_size, -1);
+	  /* intel1 */
+	  RTX_IS_SPILL_P (x) = 1;
+	  RTX_IS_SPILL_P (XEXP (x, 0)) = 1;
 #if BYTES_BIG_ENDIAN
 	  /* Cancel the  big-endian correction done in assign_stack_local.
 	     Get the address of the beginning of the slot.
@@ -2383,6 +2481,9 @@
 	  x = gen_rtx (MEM, GET_MODE (regno_reg_rtx[i]),
 		       plus_constant (XEXP (x, 0), adjust));
 	  RTX_UNCHANGING_P (x) = RTX_UNCHANGING_P (regno_reg_rtx[i]);
+	  /* intel1 */
+	  RTX_IS_SPILL_P (x) = 1;
+	  RTX_IS_SPILL_P (XEXP (x, 0)) = 1;
 	}
 
       /* Save the stack slot for later.   */
@@ -2621,6 +2722,8 @@
   int i, j;
   char *fmt;
   int copied = 0;
+  /* intel1 */
+  int indx;
 
   switch (code)
     {
@@ -2670,6 +2773,24 @@
 	     address in case it is shared.  */
 	  new = eliminate_regs (reg_equiv_memory_loc[regno],
 				mem_mode, insn);
+	  /* intel1 */
+	  if ((flag_loop_after_global || flag_peep_spills)
+	      && treplace_insn && is_a_stack_slot (new) 
+	      && !is_a_reload_stack_slot (new, &indx, cur_stack_offset, treplace_insn)
+	      && num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS)
+	    {
+              if (num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS)
+                {
+	          reload_slots[num_reload_stack_slots].cur_stack_offset 
+	            = cur_stack_offset;
+	          reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg 
+		    = regno;
+	          reload_slots[num_reload_stack_slots].reload_stack_slot 
+		    = new;
+	          reload_slots[num_reload_stack_slots++].reload_insn
+		    = treplace_insn;
+		}
+	    }
 	  if (new != reg_equiv_memory_loc[regno])
 	    {
 	      cannot_omit_stores[regno] = 1;
@@ -3066,10 +3187,14 @@
       new = eliminate_regs (XEXP (x, 0), GET_MODE (x), insn);
       if (new != XEXP (x, 0))
 	{
+	  /* intel1 */
+	  new->is_spill_rtx = x->is_spill_rtx;
 	  new = gen_rtx (MEM, GET_MODE (x), new);
 	  new->volatil = x->volatil;
 	  new->unchanging = x->unchanging;
 	  new->in_struct = x->in_struct;
+	  /* intel1 */
+	  new->is_spill_rtx = x->is_spill_rtx;
 	  return new;
 	}
       else
@@ -3260,8 +3385,12 @@
      re-recognize the insn.  We do this in case we had a simple addition
      but now can do this as a load-address.  This saves an insn in this
      common case. */
+  /* intel1 */
+  treplace_insn = replace ? insn : NULL_RTX;
 
   new_body = eliminate_regs (old_body, 0, replace ? insn : NULL_RTX);
+  /* intel1 */
+  treplace_insn = NULL_RTX;
   if (new_body != old_body)
     {
       /* If we aren't replacing things permanently and we changed something,
@@ -3777,7 +3906,6 @@
       else if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
 	{
 	  rtx avoid_return_reg = 0;
-
 #ifdef SMALL_REGISTER_CLASSES
 	  /* Set avoid_return_reg if this is an insn
 	     that might use the value of a function call.  */
@@ -3932,6 +4060,16 @@
 		  forget_old_reloads_1 (XEXP (x, 0), NULL_RTX);
 	      }
 #endif
+          /* intel1 */
+	  if (GET_CODE (PATTERN (insn)) == PARALLEL)
+	    {
+	      int i;
+	      for (i = 0; i < XVECLEN (PATTERN (insn), 0); i++)
+		update_stack_offset (XVECEXP (PATTERN (insn), 0, i), 
+		                     &cur_stack_offset);
+	    }
+	  else
+	    update_stack_offset (PATTERN (insn), &cur_stack_offset);
 	}
       /* A reload reg's contents are unknown after a label.  */
       if (GET_CODE (insn) == CODE_LABEL)
@@ -5631,6 +5769,8 @@
   int special;
   /* Values to be put in spill_reg_store are put here first.  */
   rtx new_spill_reg_store[FIRST_PSEUDO_REGISTER];
+  int indx; /* intel1 */
+  rtx tmp_stack_slot, reload_insn; /* intel1 */
 
   for (j = 0; j < reload_n_operands; j++)
     input_reload_insns[j] = input_address_reload_insns[j]
@@ -6029,9 +6169,41 @@
 					   third_reload_reg)));
 			    }
 			  else
+              /* intel1 */
+              reload_insn =
 			    gen_reload (second_reload_reg, oldequiv,
 					reload_opnum[j],
-					reload_when_needed[j]);
+			reload_when_needed[j]);
+             /* intel1 */
+             if ((flag_loop_after_global ||flag_peep_spills) 
+               &&is_a_reload_stack_slot(oldequiv,&indx,cur_stack_offset,NULL))
+              {
+                 RTX_IS_SPILL_P (reload_insn) = 1;
+                 if (indx == -1)
+                 {
+                    tmp_stack_slot
+                     = eliminate_regs (
+                     reg_equiv_memory_loc[REGNO (oldequiv)],
+                     GET_MODE (oldequiv), NULL_RTX);
+
+                     if (num_reload_stack_slots < MAX_RELOAD_ STACK_SLOTS
+                     && !is_a_reload_stack_slot (tmp_stack_slot, &indx, cur_stack_offset, NULL))
+                     {
+                        reload_slots[num_reload_stack_slots].cur_stack_offset
+                           = cur_stack_offset;
+                      reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg
+                           = REGNO (oldequiv);
+                          reload_slots[num_reload_stack_slots].reload_stack_slot
+                           = tmp_stack_slot;
+                           reload_slots[num_reload_stack_slots++].reload_insn
+                           = NULL;
+                      }
+                         SPILL_PSEUDO (reload_insn) = REGNO (oldequiv);
+                    }
+                     else
+                        SPILL_PSEUDO (reload_insn)
+                         = reload_slots[indx].stack_slot_pseudo_reg;
+                  }
 
 			  oldequiv = second_reload_reg;
 			}
@@ -6040,8 +6212,38 @@
 #endif
 
 	      if (! special && ! rtx_equal_p (reloadreg, oldequiv))
-		gen_reload (reloadreg, oldequiv, reload_opnum[j],
+		  /* intel1 */
+		reload_insn = gen_reload (reloadreg, oldequiv, reload_opnum[j],
 			    reload_when_needed[j]);
+      /* intel1 */ if ((flag_loop_after_global || flag_peep_spills)
+           && is_a_reload_stack_slot (oldequiv, &indx, cur_stack_offset, NULL))
+          {
+           RTX_IS_SPILL_P (reload_insn) = 1;
+           if (indx == -1)
+             {
+               tmp_stack_slot
+                 = eliminate_regs (
+                 reg_equiv_memory_loc[REGNO (oldequiv)],
+                 GET_MODE (oldequiv), NULL_RTX);
+
+                  if (num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS
+                     && !is_a_reload_stack_slot (tmp_stack_slot, &indx, cur_stack_offset, NULL))
+                  {
+                     reload_slots[num_reload_stack_slots].cur_stack_offset
+                      = cur_stack_offset;
+                     reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg
+                      = REGNO (oldequiv);
+                       reload_slots[num_reload_stack_slots].reload_stack_slot 
+                      = tmp_stack_slot;
+                        reload_slots[num_reload_stack_slots++].reload_insn
+                      = NULL;
+                  }
+                    SPILL_PSEUDO (reload_insn) = REGNO (oldequiv);
+              }
+            else
+              SPILL_PSEUDO (reload_insn)
+                = reload_slots[indx].stack_slot_pseudo_reg;
+          }
 
 #if defined(SECONDARY_INPUT_RELOAD_CLASS) && defined(PRESERVE_DEATH_INFO_REGNO_P)
 	      /* We may have to make a REG_DEAD note for the secondary reload
@@ -6342,6 +6544,8 @@
 		}
 	    }
 #endif
+	/* PROBLEM: supposed to be intel code here, but too much has
+	  changed above, I don't know how it maps */
 
 	  /* Output the last reload insn.  */
 	  if (! special)
@@ -6624,6 +6828,8 @@
      enum reload_type type;
 {
   rtx last = get_last_insn ();
+  /* intel1 */
+  int indx;
 
   /* How to do this reload can get quite tricky.  Normally, we are being
      asked to reload a simple operand, such as a MEM, a constant, or a pseudo
@@ -6776,7 +6982,24 @@
 
   /* If IN is a simple operand, use gen_move_insn.  */
   else if (GET_RTX_CLASS (GET_CODE (in)) == 'o' || GET_CODE (in) == SUBREG)
+  {
     emit_insn (gen_move_insn (out, in));
+    if ((flag_loop_after_global || flag_peep_spills)   /* intel1 */
+      && is_a_reload_stack_slot (in, &indx, cur_stack_offset, get_last_insn()))
+      {
+        rtx reload_insn = get_last_insn ();
+
+  RTX_IS_SPILL_P ( reload_insn) = 1;
+  if (indx == -1)
+     {
+           SPILL_PSEUDO (reload_insn) = REGNO (in);
+     }
+  else
+     SPILL_PSEUDO (reload_insn)
+        = reload_slots[indx].stack_slot_pseudo_reg;
+      }
+  }
+
 
 #ifdef HAVE_reload_load_address
   else if (HAVE_reload_load_address)
@@ -7091,4 +7314,255 @@
 	}
     }
   return count;
+}
+
+/* intel1 */
+
+/* return 1 if rx is a stack slot */
+int
+is_a_stack_slot (rx)
+  rtx rx;
+{
+ if (GET_CODE (rx) != MEM)
+    {
+      return (0);
+    }
+  if (GET_CODE (XEXP (rx, 0)) == PLUS 
+      && XEXP ( XEXP (rx, 0), 0) == stack_pointer_rtx 
+      && !frame_pointer_needed)
+    {
+      if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+        {
+          return (1);
+        }
+      else
+        {
+          return (0);
+        }
+    }
+  else if (GET_CODE (XEXP (rx, 0)) == PLUS 
+      && XEXP ( XEXP (rx, 0), 0) == frame_pointer_rtx
+      && frame_pointer_needed)
+    {
+      if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+        {
+          return (1);
+        }
+      else
+        {
+          return (0);
+        }
+    }
+  else if ((XEXP (rx, 0) == frame_pointer_rtx  && frame_pointer_needed)
+           || (XEXP (rx, 0) == stack_pointer_rtx && ! frame_pointer_needed))
+    {
+      return (1);
+    }
+  else
+    {
+      return (0);
+    }
+   
+}
+
+/*
+  if rx is a reload slot then set *indx to the index in the
+    reload_slots array which contains it and return 1
+  else
+    return 0
+*/
+
+int
+is_a_reload_stack_slot (rx, indx, cur_stack_offset, reload_insn)
+     rtx rx;
+     int *indx;
+     int cur_stack_offset;
+     rtx reload_insn;
+{
+  int i, is_based_on_stack_pointer, stack_offset, stack_i_offset;
+  rtx stack_slot_i;
+
+  
+  if (GET_CODE (rx) == REG && REGNO (rx) >= FIRST_PSEUDO_REGISTER
+      && pseudo_spilled[REGNO (rx)])
+    {
+      *indx = -1;
+      return (1);
+    }
+  if (GET_CODE (rx) == SUBREG 
+      && GET_CODE (SUBREG_REG (rx)) == MEM)
+    {
+      return (is_a_reload_stack_slot (SUBREG_REG (rx), indx, 
+                                      cur_stack_offset, reload_insn));
+    }
+  if (GET_CODE (rx) != MEM)
+    {
+      return (0);
+    }
+  is_based_on_stack_pointer = 0;
+  if (GET_CODE (XEXP (rx, 0)) == PLUS 
+      && XEXP ( XEXP (rx, 0), 0) == stack_pointer_rtx 
+      && !frame_pointer_needed)
+    {
+      is_based_on_stack_pointer = 1;
+      if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+        {
+          stack_offset = XINT (XEXP ( XEXP (rx, 0), 1), 0);
+        }
+      else
+        {
+          return (0);
+        }
+    }
+  else if (GET_CODE (XEXP (rx, 0)) == PLUS 
+      && XEXP ( XEXP (rx, 0), 0) == frame_pointer_rtx
+      && frame_pointer_needed)
+    {
+      if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+        {
+          ;
+        }
+      else
+        {
+          return (0);
+        }
+    }
+  else if ((XEXP (rx, 0) == frame_pointer_rtx  && frame_pointer_needed)
+           || (XEXP (rx, 0) == stack_pointer_rtx && ! frame_pointer_needed))
+    {
+      is_based_on_stack_pointer = (XEXP (rx, 0) == stack_pointer_rtx );
+    }
+  else
+    {
+      return (0);
+    }
+           
+
+  for (i = 0; i < num_reload_stack_slots; i++)
+    {
+      if (!is_based_on_stack_pointer)
+        {
+          if ((reload_insn == NULL || reload_insn == reload_slots[i].reload_insn)
+              && rtx_equal_p (XEXP (reload_slots[i].reload_stack_slot, 0), 
+                           XEXP (rx, 0)))
+	    {
+	      *indx = i;
+	      return (1);
+	    }
+	}
+      else
+        {
+          stack_slot_i = XEXP (reload_slots[i].reload_stack_slot, 0);
+          if (GET_CODE (stack_slot_i) == PLUS 
+              && XEXP ( stack_slot_i, 0) == stack_pointer_rtx)
+            {
+              if ( GET_CODE (XEXP ( stack_slot_i, 1)) == CONST_INT)
+                {
+                  stack_i_offset = XINT (XEXP ( stack_slot_i, 1), 0);
+                }
+              else
+                {
+                  abort ();
+                }
+            }
+          else if (stack_slot_i == stack_pointer_rtx)
+            {
+              stack_i_offset = 0;
+            }
+          else
+            {
+              abort ();
+            }
+          stack_i_offset -= reload_slots[i].cur_stack_offset;
+          if ((reload_insn == NULL || reload_insn == reload_slots[i].reload_insn)
+              && (stack_offset - cur_stack_offset == stack_i_offset))
+            {
+	      *indx = i;
+	      return (1);
+            }
+        }
+    }
+  return (0);
+}
+
+
+int
+are_same_reload_slots (slot1, offset1, slot2, offset2)
+  rtx slot1, slot2;
+  int offset1, offset2;
+{
+  rtx base_reg1, base_reg2;
+  int add_val1, add_val2;
+
+  if (GET_CODE (XEXP (slot1, 0)) == PLUS)
+    {
+      if (GET_CODE (XEXP (XEXP (slot1, 0), 0)) == REG)
+        {
+          base_reg1 = XEXP (XEXP (slot1, 0), 0);
+          if (GET_CODE (XEXP (XEXP (slot1, 0), 1)) == CONST_INT)
+            {
+              add_val1 = XINT (XEXP (XEXP (slot1, 0), 1), 0);
+            }
+        }
+    }
+  else
+    {
+      add_val1 = 0;
+      base_reg1 = XEXP (slot1, 0);
+    }
+    
+  if (GET_CODE (XEXP (slot2, 0)) == PLUS)
+    {
+      if (GET_CODE (XEXP (XEXP (slot2, 0), 0)) == REG)
+        {
+          base_reg2 = XEXP (XEXP (slot2, 0), 0);
+          if (GET_CODE (XEXP (XEXP (slot2, 0), 1)) == CONST_INT)
+            {
+              add_val2 = XINT (XEXP (XEXP (slot2, 0), 1), 0);
+            }
+        }
+    }
+  else
+    {
+      add_val2 = 0;
+      base_reg2 = XEXP (slot2, 0);
+    }
+  if (base_reg1 == frame_pointer_rtx)
+    {
+      offset1 = 0;
+    }
+  if (base_reg2 == frame_pointer_rtx)
+    {
+      offset2 = 0;
+    }
+  if (base_reg1 == base_reg2 
+      && ((add_val1 - offset1) == (add_val2 - offset2)))
+    {
+      return (1);
+    }
+  return (0);
+}
+
+/*
+  if x refernces a paramater then return 1
+  else return 0
+*/
+
+int 
+is_a_param_slot (x)
+     rtx x;
+{
+  if (GET_CODE (x) == MEM && GET_CODE (XEXP (x, 0)) == PLUS
+      && GET_CODE (XEXP (XEXP (x, 0), 0)) == REG
+      && REGNO (XEXP (XEXP (x, 0), 0)) == ARG_POINTER_REGNUM
+      && GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST_INT)
+    {
+      return (1);
+    }
+  if (GET_CODE (x) == MEM && GET_CODE (XEXP (x, 0)) == REG
+      && REGNO (XEXP (x, 0)) == ARG_POINTER_REGNUM)
+    {
+      return (1);
+    }
+  return (0);
 }
diff -r -u -H -N gcc-2.6.3/rtl.c gcc-i2.6.3/rtl.c
--- gcc-2.6.3/rtl.c	Fri Mar 25 14:17:09 1994
+++ gcc-i2.6.3/rtl.c	Wed Feb 15 22:47:24 1995
@@ -173,11 +173,12 @@
 			   "NOTE_INSN_PROLOGUE_END", "NOTE_INSN_EPILOGUE_BEG",
 			   "NOTE_INSN_DELETED_LABEL", "NOTE_INSN_FUNCTION_BEG"};
 
+/* intel1 added REG_DEP_TMP */
 char *reg_note_name[] = { "", "REG_DEAD", "REG_INC", "REG_EQUIV", "REG_WAS_0",
 			  "REG_EQUAL", "REG_RETVAL", "REG_LIBCALL",
 			  "REG_NONNEG", "REG_NO_CONFLICT", "REG_UNUSED",
 			  "REG_CC_SETTER", "REG_CC_USER", "REG_LABEL",
-			  "REG_DEP_ANTI", "REG_DEP_OUTPUT" };
+			  "REG_DEP_ANTI", "REG_DEP_OUTPUT", "REG_DEP_TMP"  };
 
 /* Allocate an rtx vector of N elements.
    Store the length, and initialize all elements to zero.  */
@@ -301,6 +302,8 @@
   copy->volatil = orig->volatil;
   copy->unchanging = orig->unchanging;
   copy->integrated = orig->integrated;
+  /* intel1 */
+  copy->is_spill_rtx = orig->is_spill_rtx;
   
   format_ptr = GET_RTX_FORMAT (GET_CODE (copy));
 
diff -r -u -H -N gcc-2.6.3/rtl.def gcc-i2.6.3/rtl.def
--- gcc-2.6.3/rtl.def	Fri May  6 17:33:49 1994
+++ gcc-i2.6.3/rtl.def	Thu Feb 16 12:57:19 1995
@@ -346,7 +346,8 @@
    ---------------------------------------------------------------------- */
 
 /* An instruction that cannot jump.  */
-DEF_RTL_EXPR(INSN, "insn", "iuueiee", 'i')
+/* intel1 added last 0 - this field is used in scheduling */
+DEF_RTL_EXPR(INSN, "insn", "iuueiee0", 'i')
 
 /* An instruction that can possibly jump.
    Fields ( rtx->fld[] ) have exact same meaning as INSN's.  */
@@ -643,7 +644,11 @@
 
 /* Operand:
      0:  value to be shifted.
-     1:  number of bits.  */
+     1:  number of bits.  
+   ASHIFT and LSHIFT are distinguished because on some machines
+   these allow a negative operand and shift right in that case.
+*/
+DEF_RTL_EXPR(LSHIFT, "lshift", "ee", '2')
 DEF_RTL_EXPR(ASHIFT, "ashift", "ee", '2')
 DEF_RTL_EXPR(ROTATE, "rotate", "ee", '2')
 
diff -r -u -H -N gcc-2.6.3/rtl.h gcc-i2.6.3/rtl.h
--- gcc-2.6.3/rtl.h	Thu Sep  1 22:13:31 1994
+++ gcc-i2.6.3/rtl.h	Wed Feb 15 22:47:24 1995
@@ -139,6 +139,9 @@
      In a REG, nonzero means this reg refers to the return value
      of the current function.  */
   unsigned integrated : 1;
+  /* intel1 Nonzero if this rtx is a spill rtx */
+  /* intel2 overlap: Nonzero if this rtx was created by memory_simplify */
+  unsigned is_spill_rtx: 1;
   /* The first element of the operands of this rtx.
      The number of operands and their types are controlled
      by the `code' field, according to rtl.def.  */
@@ -210,6 +213,10 @@
 
 #define RTX_INTEGRATED_P(RTX) ((RTX)->integrated)
 #define RTX_UNCHANGING_P(RTX) ((RTX)->unchanging)
+/* intel1 */
+#define RTX_IS_SPILL_P(RTX) ((RTX)->is_spill_rtx)
+/* intel2 - see a note above (for is_spill_rtx field) */
+#define RTX_IS_RISC_P(RTX) ((RTX)->is_spill_rtx)
 
 /* RTL vector.  These appear inside RTX's when there is a need
    for a variable number of things.  The principle use is inside
@@ -258,6 +265,11 @@
 #define PREV_INSN(INSN)	((INSN)->fld[1].rtx)
 #define NEXT_INSN(INSN)	((INSN)->fld[2].rtx)
 
+/* intel1 used in sched*/
+#define ORG_NEXT_INSN(INSN)	((INSN)->fld[7].rtx)
+/* intel1 used in (loop) opt of spills */
+#define SPILL_PSEUDO(INSN)	((INSN)->fld[7].rtint)
+
 /* The body of an insn.  */
 #define PATTERN(INSN)	((INSN)->fld[3].rtx)
 
@@ -347,7 +359,7 @@
 		REG_EQUAL = 5, REG_RETVAL = 6, REG_LIBCALL = 7,
 		REG_NONNEG = 8, REG_NO_CONFLICT = 9, REG_UNUSED = 10,
 		REG_CC_SETTER = 11, REG_CC_USER = 12, REG_LABEL = 13,
-		REG_DEP_ANTI = 14, REG_DEP_OUTPUT = 15 };
+		REG_DEP_ANTI = 14, REG_DEP_OUTPUT = 15, REG_DEP_TMP = 16 };
 
 /* Define macros to extract and insert the reg-note kind in an EXPR_LIST.  */
 #define REG_NOTE_KIND(LINK) ((enum reg_note) GET_MODE (LINK))
